// WinMain.c
#include <windows.h>
#include "WinMain.h"

//////////////////////////////////
// O[oϐB

const char *const APP_NAME = "MxA02_VC6";       // AvP[V̖OłB
const char *const CLASS_NAME = "MxA02WndClass";	// EBhENXłB

HINSTANCE g_hInstance; // ̃AvP[ṼCX^XnhłB

////////////////////////////////////////////////////////////////////
// WindowsŏɌĂ΂֐łB

int WINAPI WinMain
	( HINSTANCE p_hInstance
	, HINSTANCE p_hPrevInst
	, LPSTR p_pchCmdLine
	, int p_iCmdShow
	)
{
	// CX^XnhO[oϐɎĂ܂B
	g_hInstance = p_hInstance;

	// EBhENXo^܂B
	if( RegisterWindowClass() == FALSE )
	{
		return FALSE;
	}

	// EBhE̕\s܂B
	if( CreateAndShowWindow( p_iCmdShow ) == FALSE )
	{
		return FALSE;
	}

	// bZ[W[vJn܂B
	return MessageLoop();
}

////////////////////////////////////////////////////////////////////
// EBhENXo^܂B

BOOL RegisterWindowClass()
{
	// EBhENX̏i[\̂łB
	WNDCLASS stWndClass;

	// ǂȃEBhENX̂AݒZbg܂B
	stWndClass.style = CS_BYTEALIGNWINDOW | CS_HREDRAW | CS_VREDRAW;
	stWndClass.lpfnWndProc = WndProc;
	stWndClass.cbClsExtra = 0;
	stWndClass.cbWndExtra = 0;
	stWndClass.hInstance = g_hInstance;
	stWndClass.hIcon = LoadIcon( NULL, IDI_EXCLAMATION );
	stWndClass.hCursor = LoadCursor( NULL, IDC_ARROW );
	stWndClass.hbrBackground = (HBRUSH)COLOR_BACKGROUND;
	stWndClass.lpszMenuName = NULL;
	stWndClass.lpszClassName = CLASS_NAME;

	// EBhENXo^܂B
	if( RegisterClass( &stWndClass ) == 0 )
	{
		return FALSE;
	}

	return TRUE;
}

////////////////////////////////////////////////////////////////////
// EBhE쐬ĕ\܂B

BOOL CreateAndShowWindow( int p_iCmdShow )
{
	// EBhEnhĂϐB
	HWND hWnd;

	// EBhE쐻܂B
	hWnd = CreateWindow
		( CLASS_NAME
		, APP_NAME
		, WS_OVERLAPPEDWINDOW
		, CW_USEDEFAULT
		, 0
		, CW_USEDEFAULT
		, 0
		, NULL
		, NULL
		, g_hInstance
		, NULL
		);

	// EBhEł`FbN܂B
	if( hWnd == NULL )
	{
		return FALSE;
	}

	// EBhE\܂B
	ShowWindow( hWnd, p_iCmdShow );
	UpdateWindow( hWnd );

	return TRUE;
}

////////////////////////////////////////////////////////////////////
// bZ[W[vłB

int MessageLoop()
{
	BOOL bRes;
	MSG stMsg;

	// bZ[W[vłB
	while( 1 )
	{
		// bZ[WL[o܂B
		bRes = GetMessage( &stMsg, NULL, 0, 0 );
		if(
		  ( bRes == 0 ) ||
		  ( bRes == -1 )
		  )
		{
			// ÎŃ[v甲܂B
			break;
		}

		// bZ[Wϊ܂B
		TranslateMessage( &stMsg );
		// EBhEvV[Wɑ܂B
		DispatchMessage( &stMsg );
	}

	return stMsg.wParam;
}

////////////////////////////////////////////////////////////////////
// EBhEvV[WłB

LRESULT CALLBACK WndProc
	( HWND p_hWnd
	, UINT p_uiMsg
	, WPARAM p_wParam
	, LPARAM p_lParam
	)
{
	// bZ[W܂B
	switch( p_uiMsg )
	{
	case WM_PAINT:
		// ĕ`𑣂ꂽƂB
		// EBhEɕ`悵܂B
		WriteHelloWorld( p_hWnd );
		return 0;

	case WM_DESTROY:
		// {^ꂽƂB
		// AvP[VI܂B
		PostQuitMessage( 0 );
		return 0;
	}

	return DefWindowProc( p_hWnd, p_uiMsg, p_wParam, p_lParam );
}

////////////////////////////////////////////////////////////////////
// Hello World!Əo͂܂B

void WriteHelloWorld( HWND p_hPaintWnd )
{
	// ޕB
	const char *const pchOutput = "Hello, world!";

	HDC hPaintDC;
	PAINTSTRUCT stPaint;

	// foCXReLXgւ̃nh擾܂B
	hPaintDC = BeginPaint( p_hPaintWnd, &stPaint );

	// ̃nhʂĕo͂܂B
	TextOut( hPaintDC, 0, 0, pchOutput, strlen( pchOutput ) );

	// foCXReLXgւ̕`I܂B
	EndPaint( p_hPaintWnd, &stPaint );

	return;
}